package com.landray.kmss.sys.attachment.integrate.wps.util;

import javax.net.ssl.SSLSocketFactory;
import java.net.URLConnection;
import java.io.IOException;
import javax.net.ssl.HttpsURLConnection;
import java.security.SecureRandom;
import javax.net.ssl.KeyManager;
import javax.net.ssl.TrustManager;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import javax.net.ssl.X509TrustManager;
import javax.net.ssl.SSLContext;
import com.landray.kmss.util.StringUtil;
import java.net.URL;
import java.io.InputStream;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

public class FileDowloadUtil
{
    private static Logger logger;
    
    static {
        FileDowloadUtil.logger = LoggerFactory.getLogger(FileDowloadUtil.class);
    }
    
    public static InputStream getFileInputStream(final String sUrl) throws Exception {
        if (FileDowloadUtil.logger.isDebugEnabled()) {
            FileDowloadUtil.logger.debug("ThirdWpsWebhookServiceImp.getFileInputStream下载地址：" + sUrl);
        }
        InputStream is = null;
        HttpsURLConnection connssl = null;
        URLConnection conn = null;
        try {
            final URL url = new URL(sUrl);
            if (StringUtil.isNotNull(sUrl) && sUrl.startsWith("https")) {
                final SSLContext ctx = SSLContext.getInstance("SSL");
                final X509TrustManager tm = new X509TrustManager() {
                    @Override
                    public void checkClientTrusted(final X509Certificate[] xcs, final String string) throws CertificateException {
                    }
                    
                    @Override
                    public void checkServerTrusted(final X509Certificate[] xcs, final String string) throws CertificateException {
                    }
                    
                    @Override
                    public X509Certificate[] getAcceptedIssuers() {
                        return null;
                    }
                };
                ctx.init(null, new TrustManager[] { tm }, null);
                final SSLSocketFactory ssf = ctx.getSocketFactory();
                connssl = (HttpsURLConnection)url.openConnection();
                connssl.setConnectTimeout(5000);
                connssl.setReadTimeout(3600000);
                connssl.setSSLSocketFactory(ssf);
                is = connssl.getInputStream();
            }
            else {
                conn = url.openConnection();
                conn.connect();
                is = conn.getInputStream();
            }
        }
        catch (final Exception ex) {
            FileDowloadUtil.logger.error("下载出错", ex);
            if (is != null) {
                try {
                    is.close();
                }
                catch (final IOException e) {
                    e.printStackTrace();
                    throw e;
                }
            }
            throw ex;
        }
        if (FileDowloadUtil.logger.isDebugEnabled()) {
            FileDowloadUtil.logger.debug("ThirdWpsWebhookServiceImp.getFileInputStream下载转流成功");
        }
        return is;
    }
}
